package quotes;

/**
 * @author delpiano
 *
 * A Subcriber is an entity which is able to receive and eventually process messages from
 * different <code>Channel</code>s.
 */
public interface Subscriber {
	
	/** Receives and eventually processes a message from a given <code>Channel</code>s.
	 * @param received_from_channel the channel the message comes from,
	 * @param message_source the sender of the message,
	 * @param message the message itself.
	 */
	void receiveMessage(Channel received_from_channel , Object message_source , Object message);

}
