package quotes.local;

import java.awt.GridLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;

import javax.swing.JPanel;

/**
 * @author delpiano
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class CompositeConsole extends JPanel {
	
	private static int latest_instance_number = 0;
	
	private List consoles = new LinkedList();
	
	private int instance_number;
	private int number_of_components;
	
	/**
	 * @see java.lang.Object#Object()
	 */
	public CompositeConsole() {
		super();
		instance_number = latest_instance_number++;
	}
	
	/**
	 * Method addConsole.
	 * @param new_console :
	 */
	public void addConsole(Component new_console) {
		number_of_components++;
		consoles.add(new_console);
	}
	
	/**
	 * Method removeConsole.
	 * @param new_console :
	 */
	public void removeConsole(Component new_console) {
		consoles.remove(new_console);
	}
	
	/**
	 * @see java.awt.Component#getPreferredSize()
	 */
	public Dimension getPreferredSize() {
		return new Dimension(500 , 500);
	}
	
	/**
	 * @see java.lang.Object#finalize()
	 */
	public void finalize() {
		this.setLayout(new GridLayout(1 , consoles.size()));
		for (Iterator it = consoles.iterator() ; it.hasNext() ;) {
			JPanel pnl = (JPanel) it.next();
			
			if (pnl instanceof CompositeConsole) {
				((CompositeConsole) pnl).finalize();
			}
			
			add(pnl);
		}
		validate();
	}	
	
	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "[" + instance_number + "] " + super.toString();
	}

}
